#!python

# test script for the emxrt module

import emxrt, os

# make sure test file doesn't already exist before creating it
test_file = 'test.dat'
try:
	os.unlink(test_file)
except IOError:
	pass
open(test_file, 'w').write('yessir!\n')

print 'initial extended attributes (should be empty):'
print emxrt.ea_getall(test_file)

print 'try and get a dummy attribute (should get KeyError):'
try:
	print emxrt.ea_get(test_file, 'HELP')
except KeyError:
	print 'caugth expected KeyError'

print 'saving a value to an attribute:'
emxrt.ea_put(test_file, 'HELP', 'www.python.org')

print 'retrieving the value just saved:'
print emxrt.ea_get(test_file, 'HELP')

print 'checking what other EAs are there:'
print emxrt.ea_getall(test_file)

print 'removing the attribute just saved:'
emxrt.ea_remove(test_file, 'HELP')
print emxrt.ea_getall(test_file)

z1 = {'Z1': ['andrew', 0], 'Z2': ['i', 0], 'Z3': ['macintyre', 0]}
z2 = {'Z0': ['Andrew', 0], 'Z1': ['Iain', 0], 'Z2': ['MacIntyre', 0]}
z3 = {'Z4': ['PO Box 370', 0], 'Z5': ['Belconnen  ACT  2616', 0]}

print 'adding a group of EAs one by one:'
for i in z1.keys():
	emxrt.ea_put(test_file, i, z1[i][0])
print emxrt.ea_getall(test_file)

print 'doing a global EA update:'
emxrt.ea_putall(test_file, z2)
print emxrt.ea_getall(test_file)

print 'merging additional EAs:'
emxrt.ea_putall(test_file, z3, 1)
print emxrt.ea_getall(test_file)

print 'cleaning all EAs out:'
emxrt.ea_putall(test_file, {})
print emxrt.ea_getall(test_file)

# remove the test file
os.unlink(test_file)
